//+------------------------------------------------------------------+
//|                                                  Boll_Pocket.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DarkOrange
#property indicator_color2 SteelBlue
#property indicator_color3 DarkOrange
#property indicator_color4 DarkOrange
#property indicator_color5 Red
#property indicator_color6 Green
#property indicator_color7 Pink
//---- input parameters
extern int       Boll1_Period=102;
extern int       Boll2_Period=200;
extern int       Dev=2;
extern int       Candle_W=2;
extern int       LineStyle = 2;
extern int       LineStyle2 = 1;
extern bool      showMean = false;
extern bool      shadeHiLo = false;
//---- buffers

double Boll1Upper[];
double Boll1Lower[];
double Boll2Upper[];
double Boll2Lower[];
double BollAvMean[];
double CandleLong[];
double CandleShort[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   SetIndexBuffer(2,Boll1Upper);SetIndexStyle(2,DRAW_LINE,LineStyle);
   
   SetIndexBuffer(3,Boll1Lower);SetIndexStyle(3,DRAW_LINE,LineStyle);
   
   SetIndexBuffer(4,Boll2Upper);SetIndexStyle(4,DRAW_LINE,LineStyle2);
   
   SetIndexBuffer(5,Boll2Lower);SetIndexStyle(5,DRAW_LINE,LineStyle2);
   
   SetIndexBuffer(6,BollAvMean);SetIndexStyle(6,DRAW_LINE,LineStyle);

   SetIndexBuffer(0,CandleLong);SetIndexStyle(0,DRAW_HISTOGRAM,2,Candle_W);
   
   SetIndexBuffer(1,CandleShort);SetIndexStyle(1,DRAW_HISTOGRAM,2,Candle_W);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
     //int Cpos=Bars-counted_bars-1;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
       //---Upper Bands---+
        Boll1Upper[i]=iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_UPPER,i);
        Boll2Upper[i]=iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_UPPER,i);
        //---Lower Bands---+
        Boll1Lower[i]=iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_LOWER,i);
        Boll2Lower[i]=iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_LOWER,i);
        //---Av Mean Bands---+
        if(showMean !=false)
        BollAvMean[i]=((iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_MAIN,i))+(iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_MAIN,i)))/2;
       
        //---Candle Coloring---+
        
        double shortit=0,longit=0;
        //---Short Possibilities---+
        if(iClose(NULL,0,i)>Boll1Upper[i] && iClose(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iOpen(NULL,0,i)>Boll1Upper[i] && iOpen(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iLow(NULL,0,i)>Boll1Upper[i] && iLow(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iHigh(NULL,0,i)>Boll1Upper[i] && iHigh(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iHigh(NULL,0,i)>Boll2Upper[i] && iLow(NULL,0,i)<Boll1Upper[i])shortit=2;
        if(iHigh(NULL,0,i)>Boll2Upper[i] && iHigh(NULL,0,i)>Boll1Upper[i])shortit=2;
        
        //---Long Possibilities---+
        if(iClose(NULL,0,i)>Boll1Lower[i] && iClose(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iOpen(NULL,0,i)>Boll1Lower[i] && iOpen(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iLow(NULL,0,i)>Boll1Lower[i] && iLow(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iHigh(NULL,0,i)>Boll1Lower[i] && iHigh(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iHigh(NULL,0,i)>Boll2Lower[i] && iLow(NULL,0,i)<Boll1Lower[i])longit=1;
        if(iHigh(NULL,0,i)<Boll2Lower[i] && iHigh(NULL,0,i)<Boll1Lower[i])longit=1;
        
        //---Shade Complete Candle---+
        if (shortit==2 && shadeHiLo!=false)
        {
       CandleLong[i]=iHigh(NULL,0,i);
       CandleShort[i]=iLow(NULL,0,i);
        }
        
        if (longit==1 && shadeHiLo!=false)
       {
       CandleLong[i]=iLow(NULL,0,i);
       CandleShort[i]=iHigh(NULL,0,i);
       }
       //---Shade Open to Close of Candle---+
        if (shortit==2 && shadeHiLo!=true)
        {
       CandleLong[i]=iOpen(NULL,0,i);
       CandleShort[i]=iClose(NULL,0,i);
        }
        
        if (longit==1 && shadeHiLo!=true)
       {
       CandleLong[i]=iOpen(NULL,0,i);
       CandleShort[i]=iClose(NULL,0,i);
       }       
       
       
       }
  //---- done
     return(0);
    }
//+------------------------------------------------------------------+